{=======================================================================================================================

   " ".

     , .

========================================================================================================================

  :

  16.02.2015 [*]       ( 8).
  10.03.2012 [+]       dmComming.SetCommingValue.
             [+]   " "    .
             [-]  uses.
  26.02.2012 [*]  .
  20.02.2012 [*] .
  09.02.2012 [!]    Delphi XE2.
  30.03.2011 [*]    .
  04.08.2009 [+]     btExit.
  17.06.2008 [+]  .  .
  09.10.1997 [!]  .

========================================================================================================================
  Copyright 19972015 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: fmChangeList.pas,v 1.10 2015/03/08 05:02:27 tsk Exp $
=======================================================================================================================}
unit fmChangeList;

interface

uses  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls, Mask, DBGridEh, ADODB,
      ToolWin, ComCtrls, DB, DBCtrls, Grids, ExtCtrls, Buttons, ActnList, PropFilerEh, PropStorageEh, DBGridEhGrouping,
      GridsEh, ToolCtrlsEh, DBGridEhToolCtrls, DynVarsEh, System.Actions, DBAxisGridsEh,
      // Comming & ComputerWare:
      CommingADO, dmCommingData;

type
  TChangeListFM = class( TForm )
    spPos: TSplitter;
    grDevice: TDBGridEh;
    grModel: TDBGridEh;
    dsModel: TDataSource;
    dsDevice: TDataSource;
    taModel: TADODataSet;
    taDevice: TADODataSet;
    tbDoc: TToolBar;
    alDoc: TActionList;
    acRefreshDoc: TAction;
    stMain: TPropStorageEh;
    ToolButton6: TToolButton;
    ToolButton5: TToolButton;
    acGoDevice: TAction;
    ToolButton9: TToolButton;
    taModelID: TIntegerField;
    taModelName: TStringField;
    taDevicePlace: TStringField;
    taDeviceNumber: TStringField;
    taDeviceDateLast: TDateTimeField;
    taDeviceDateNext: TDateTimeField;
    taDeviceID: TIntegerField;
    taDeviceElement: TIntegerField;
    procedure btExitClick(Sender: TObject);
    procedure acGoDeviceUpdate(Sender: TObject);
    procedure acGoDeviceExecute(Sender: TObject);
    procedure grDeviceGetCellParams(Sender: TObject; Column: TColumnEh;
                                                          AFont: TFont; var Background: TColor; State: TGridDrawState);
    procedure acRefreshDocExecute(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private   { Private declarations }
    procedure   RefreshModel( ID: Integer = -1; IDPos: Integer = -1 );
  public    { Public declarations }
  end;

var ChangeListFM: TChangeListFM;

implementation

uses fmLayout, fmMain;
{$R *.DFM}
//======================================================================================================================
{procedure ChangeListRun;
  var cv: String;
begin
  Screen.Cursor := crHourGlass;
  try
    if ChangeListFM = nil then Application.CreateForm( TChangeListFM, ChangeListFM );
    with ChangeListFM do begin
      if WindowState = wsMinimized then WindowState := wsNormal;
//      cv := dmComming.GetCommingValue( cdChangeStand );
      RefreshModel( StrToIntDef( Copy( cv, 1, 8 ), 0 ), StrToIntDef( Copy( cv, 9, 8 ), 0 ));
      Show;
    end;
  finally
    Screen.Cursor := crDefault;
  end;
end;}
//======================================================================================================================
{ TChangeListFM }
//======================================================================================================================
procedure TChangeListFM.FormCreate(Sender: TObject);
begin
  taModel.Open;
  taDevice.Open;
end;
//======================================================================================================================
procedure TChangeListFM.FormShow( Sender: TObject );
begin
//  Width   := mainFM.tsChage.ClientWidth;
//  Height  := mainFM.tsChage.ClientHeight;
end;
//======================================================================================================================
procedure TChangeListFM.RefreshModel( ID, IDPos: Integer );
begin
  Screen.Cursor := crHourGlass;
  RequeryParameters( taModel, []);
  taModel.Locate('ID', ID, [] );
  RequeryParameters( taDevice, [ ID ]);
  taDevice.Locate('ID', IDPos, [] );
  Screen.Cursor := crDefault;
end;
//======================================================================================================================
procedure TChangeListFM.acGoDeviceUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := ( taDevice.Active ) and ( taDevice.RecordCount > 0 );
end;
//======================================================================================================================
procedure TChangeListFM.acGoDeviceExecute(Sender: TObject);
begin
//  LayoutListRun( 'M', taDeviceElement.Value );
end;
//======================================================================================================================
procedure TChangeListFM.btExitClick(Sender: TObject);
begin
  Application.Terminate;
end;
//======================================================================================================================
procedure TChangeListFM.grDeviceGetCellParams( Sender: TObject; Column: TColumnEh;
                                               AFont: TFont; var Background: TColor;
                                               State: TGridDrawState);
begin
  if Column.Field = taDeviceDateNext then begin
    if not taDeviceDateNext.IsNull then begin
      if taDeviceDateNext.Value < Date
        then AFont.Color := clRed
        else if taDeviceDateNext.Value < ( Date + 30 )
          then AFont.Color := clGreen;
    end;
  end;
end;
//======================================================================================================================
procedure TChangeListFM.acRefreshDocExecute(Sender: TObject);
begin
  RefreshModel( taModelID.Value, taDeviceID.Value );
end;
//======================================================================================================================
end.







