{=======================================================================================================================

   "".

     , , .

========================================================================================================================

  :

  05.03.2015 [+]   .
  26.02.2015 [+] , , , .
  25.02.2015 [*] .
             [+]  .
  09.10.1997 [!]  .

========================================================================================================================
  Copyright 19972015 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: dgDocumentKindList.pas,v 1.5 2015/03/08 05:02:35 tsk Exp $
=======================================================================================================================}
unit dgDocumentKindList;

interface

uses  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, Dialogs, DB, StdCtrls, Buttons, Grids,
      DBGridEh, ExtCtrls, DBCtrls, ADODB, DBGridEhGrouping, GridsEh, ToolCtrlsEh, DBGridEhToolCtrls, DynVarsEh,
      DBAxisGridsEh,
      // ComputerWare & Comming:
      CommingADO, CommingDialog, dgBaseList;

type
  TDocumentKindListDG = class(TBASEListDG)
    taKind: TADODataSet;
    taKindID: TStringField;
    taKindName: TStringField;
    taKindUses: TIntegerField;
    procedure btBackClick(Sender: TObject);
    procedure btInsertClick(Sender: TObject);
    procedure btEditClick(Sender: TObject);
    procedure btDeleteClick(Sender: TObject);
    procedure btRefreshClick(Sender: TObject);
  private   { Private declarations }
    procedure RefreshData( Code: String = '');
  public    { Public declarations }
    function Run( ID: Integer = -1; InField: TField = nil ): Integer ;
  end;

var  DocumentKindListDG: TDocumentKindListDG;

implementation

{$R *.dfm}

uses dgDocumentKindEdit;
//======================================================================================================================
{ TDocumentKindListDG }
//======================================================================================================================
function TDocumentKindListDG.Run( ID: Integer; InField: TField ): Integer;
begin
  if DocumentKindListDG = nil then Application.CreateForm( TDocumentKindListDG, DocumentKindListDG);
  with DocumentKindListDG do begin
    RequeryParameters( taKind, [] );
    Field := InField;
    Result := ShowModal;
  end;
end;
//======================================================================================================================
procedure TDocumentKindListDG.RefreshData( Code: String );
begin
  if (Code = EmptyStr) then Code := taKindID.AsString;
  RequeryParameters( taKind, [] );
  taKind.Locate( 'ID', Code, []);
end;
//======================================================================================================================
procedure TDocumentKindListDG.btInsertClick(Sender: TObject);
begin
//  inherited;
  if DocumentKindEditDG.Run( '' ) then RefreshData( DocumentKindEditDG.taDataID.AsString );
end;
//======================================================================================================================
procedure TDocumentKindListDG.btEditClick(Sender: TObject);
begin
//  inherited;
  if DocumentKindEditDG.Run( taKindID.AsString ) then RefreshData( DocumentKindEditDG.taDataID.AsString );
end;
//======================================================================================================================
procedure TDocumentKindListDG.btDeleteClick(Sender: TObject);
begin
//  inherited;
  if ShowAskDelete( taKindName.AsString ) then begin
    DeleteRecord( 'DocKind', taKindID );
    taKind.Prior;
    RefreshData;
  end;
end;
//======================================================================================================================
procedure TDocumentKindListDG.btRefreshClick(Sender: TObject);
begin
//  inherited;
  RefreshData;
end;
//======================================================================================================================
procedure TDocumentKindListDG.btBackClick(Sender: TObject);
begin
  inherited;
  SetBackValue( taKindID.Value );
end;
//======================================================================================================================
end.
