{=======================================================================================================================

   " ".

    , , .

========================================================================================================================

  :

  26.02.2015 [*]     .
  25.02.2015 [-] TPropStorageEh.
  12.03.2012 [!]  .
  26.02.2012 [*] .
  09.02.2012 [!]    Delphi XE2.
  11.02.2007 [*]     DBLookupCombobox.
  20.03.2007 [*]   XP.
  19.11.2001 [*]     ADO.
             [*]  .
  12.11.2001 [*]    ,     .
  08.11.2001 [*]    .
             [-]  TAB.
  01.01.1999 [+]  .  .
  09.10.1997 [!]  .

========================================================================================================================
  Copyright 19972015 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: dgDocumentEdit.pas,v 1.4 2015/03/08 05:02:35 tsk Exp $
=======================================================================================================================}
unit dgDocumentEdit;

interface

uses  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, DB, ADODB, StdCtrls, DBCtrls, Buttons,
      DBCtrlsEh, DBLookupEh, Mask, ExtCtrls, DBGridEh,
      // Base, Comming & ComputerWare:
      dgBaseEdit, CommingADO, dmLookUpData;

type
  TDocumentEditDG = class( TBASEEditDG )
    lcProd: TDBLookupComboboxEh;
    Label5: TLabel;
    sbProd: TSpeedButton;
    lcKind: TDBLookupComboboxEh;
    DBEdit1: TDBEdit;
    Label1: TLabel;
    Label2: TLabel;
    edDate: TDBDateTimeEditEh;
    Label3: TLabel;
    DBMemo1: TDBMemo;
    Label4: TLabel;
    taDataIdDocument: TAutoIncField;
    taDataDocKind: TStringField;
    taDataDocNumber: TStringField;
    taDataDocDate: TDateTimeField;
    taDataDocClient: TIntegerField;
    taDataNote: TStringField;
    sbFind: TSpeedButton;
    procedure sbProdClick(Sender: TObject);
    procedure taDocAfterInsert(DataSet: TDataSet);
    procedure FormCreate(Sender: TObject);
  private   { Private declarations }
  public    { Public declarations }
    function Run( Doc: Integer = -1 ): Boolean;
  end;

var DocumentEditDG: TDocumentEditDG;

implementation
{$R *.DFM}

uses dgFirmList;
//======================================================================================================================
{ DocumentEditDG }
//======================================================================================================================
procedure TDocumentEditDG.FormCreate(Sender: TObject);
begin
  inherited;
  lcKind.ListSource := dmLookUp.dsDocKind;
  lcProd.ListSource := dmLookUp.dsClient;
end;
//======================================================================================================================
function TDocumentEditDG.Run( Doc: Integer ): Boolean;
begin
  if DocumentEditDG = nil then Application.CreateForm(TDocumentEditDG, DocumentEditDG);
  with DocumentEditDG do begin
    RequeryParameters( dmLookUp.taDocKind, []);
    RequeryParameters( dmLookUp.taClient, []);
    RequeryParameters( taData, [ Doc ]);
    Result := ( ShowModal = mrOk );
  end;
end;
//======================================================================================================================
procedure TDocumentEditDG.sbProdClick(Sender: TObject);
begin
  if FirmListDG.Run( taDataDocClient.Value, taDataDocClient ) = mrOK then RequeryParameters( dmLookUp.taClient, []);
end;
//======================================================================================================================
procedure TDocumentEditDG.taDocAfterInsert(DataSet: TDataSet);
begin
  if taDataDocKind.IsNull then taDataDocKind.Value  := 'N';
  if taDataDocDate.IsNull then taDataDocDate.Value  := Trunc( Now );
end;
//======================================================================================================================
end.
