{=======================================================================================================================

   "".

      ,  , .

========================================================================================================================

  :

  11.04.2012 [*]  -   "".
             [*]   .
  04.04.2012 [+]  .  .
  09.10.1997 [!]  .

========================================================================================================================
  Copyright 19972012 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: dgUserInstall.pas,v 1.3 2015/03/08 05:02:41 tsk Exp $
=======================================================================================================================}
unit dgUserInstall;

interface

uses  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, Dialogs, DB, StdCtrls, Buttons, Grids,
      DBGridEh, ExtCtrls, DBCtrls, ADODB, PropFilerEh, PropStorageEh, DBGridEhGrouping, GridsEh, ShellAPI,
      // ComputerWare:
      dgBaseList,
      // Comming:
      CommingADO, ToolCtrlsEh, DBGridEhToolCtrls, DynVarsEh, DBAxisGridsEh;

type
  TUserInstallDG = class(TBASEListDG)
    taUser: TADODataSet;
    taUserID: TAutoIncField;
    taUserLine: TIntegerField;
    taUserTitle: TBooleanField;
    taUserName: TStringField;
    taUserDone: TBooleanField;
    spInsert: TADOStoredProc;
    taUserUser: TIntegerField;
    btPrint: TSpeedButton;
    procedure grListGetCellParams(Sender: TObject; Column: TColumnEh; AFont: TFont; var Background: TColor;
                                                                                                State: TGridDrawState);
    procedure btPrintClick(Sender: TObject);
  private   { Private declarations }
    procedure InsertInstall( ID: Integer);
    procedure RefreshData( ID: Integer );
  public    { Public declarations }
    function Run( ID: Integer): Integer ;
  end;

var  UserInstallDG: TUserInstallDG;

implementation

{$R *.dfm}
//======================================================================================================================
{ TUserInstallDG }
//======================================================================================================================
function TUserInstallDG.Run( ID: Integer): Integer;
begin
  if UserInstallDG = nil then Application.CreateForm( TUserInstallDG, UserInstallDG );
  with UserInstallDG do begin
    RequeryParameters( taUser, [ ID ] );
    if taUser.RecordCount = 0 then InsertInstall( ID );
    Result := ShowModal;
  end;
end;
//======================================================================================================================
procedure TUserInstallDG.RefreshData(ID: Integer);
begin
  RequeryParameters( taUser, [ ID ] );
end;
//======================================================================================================================
procedure TUserInstallDG.InsertInstall( ID: Integer );
begin
  spInsert.Parameters[1].Value := ID;
  spInsert.ExecProc;
  RefreshData( ID );
end;
//======================================================================================================================
procedure TUserInstallDG.grListGetCellParams(Sender: TObject; Column: TColumnEh; AFont: TFont; var Background: TColor;
  State: TGridDrawState);
begin
  if taUserTitle.Value then Background := clActiveBorder;
end;
//======================================================================================================================
{procedure TUserInstallDG.nvListBeforeAction(Sender: TObject; Button: TNavigateBtn);
begin
  if Button = nbInsert then begin
    InsertInstall( taUserUser.Value );
    Abort;
  end;
  if ( Button = nbDelete ) and (( taUserTitle.Value ) or ( taUserLine.Value < 100)) then Abort;
  if ( Button = nbEdit ) and not (( taUserTitle.Value ) or ( taUserLine.Value < 100)) then begin
    taUser.Edit;
    taUserDone.Value := not taUserDone.Value;
    taUser.Post;
    RefreshData( taUserUser.Value );
    Abort;
  end;
  if Button = nbRefresh then begin
    RefreshData( taUserUser.Value );
    Abort;
  end;
end;}
//======================================================================================================================
procedure TUserInstallDG.btPrintClick(Sender: TObject);
  var URL: String;
begin
  URL := 'http://sreport.filit.ru/ReportServer/Pages/ReportViewer.aspx?%2fComputerWare%2fuser.install&rs:Command=Render&User='
          + taUserUser.AsString;
  ShellExecute( Application.Handle, 'open', PWChar( URL ), nil, nil, SW_SHOWNORMAL);
end;
//======================================================================================================================
end.
