/*=====================================================================================================================

   " ".

     .

=======================================================================================================================

  :

  14.05.2012 [-] UserInstallInsert:   .
  10.05.2012 [*] UserInstallInsert:   .
  02.05.2012 [*] UserInstallInsert:  .
  11.04.2012 [*] GridUserInstall:  "".
             [*] UserInstallInsert: .
  10.04.2012 [*] UserInstallInsert:  .
  04.04.2012 [+] GridUserInstall:   .
             [+] UserInstallInsert:     UserInstallDefault.
             [+]  .
  09.10.1997 [!]  .

========================================================================================================================
  Copyright 19972012 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: scInstall.sql,v 1.6 2012/07/02 03:52:04 tsk Exp $
=====================================================================================================================*/
USE ComputerWare
--
EXECUTE CheckDropProcedure 'UserInstallInsert'
EXECUTE CheckDropProcedure 'GridUserInstall'
--
GO
--=====================================================================================================================
CREATE PROCEDURE UserInstallInsert @US INT
AS
  SET NOCOUNT ON
  IF NOT EXISTS ( SELECT ID FROM UserInstall WHERE([User] = @US) AND (Line = 10))
    INSERT INTO UserInstall ([User], Line, Title, Name)
         SELECT ID, 10, 1, '' + CASE DomainSource WHEN 1 THEN '  ' + Domain END
           FROM [User] WHERE ([User].ID = @US)
  IF NOT EXISTS ( SELECT ID FROM UserInstall WHERE([User] = @US) AND (Line = 11))
    INSERT INTO UserInstall ([User], Line, Name)
         SELECT ID, 11, ' : ' + [Login]
           FROM [User] WHERE ([User].ID = @US)
  IF NOT EXISTS ( SELECT ID FROM UserInstall WHERE([User] = @US) AND (Line = 12))
    INSERT INTO UserInstall ([User], Line, Name)
         SELECT ID, 12, ': ' + Pass
           FROM [User] WHERE ([User].ID = @US)
  IF NOT EXISTS ( SELECT ID FROM UserInstall WHERE([User] = @US) AND (Line = 15))
    INSERT INTO UserInstall ([User], Line, Name)
         SELECT ID, 15, ': ' + [User].[Name]
           FROM [User] WHERE ([User].ID = @US)
  IF NOT EXISTS ( SELECT ID FROM UserInstall WHERE([User] = @US) AND (Line = 16))
    INSERT INTO UserInstall ([User], Line, Name)
         SELECT ID, 16, ': '
           FROM [User] WHERE ([User].ID = @US)
  IF NOT EXISTS ( SELECT ID FROM UserInstall WHERE([User] = @US) AND (Line = 20))
    INSERT INTO UserInstall ([User], Line, Name)
         SELECT ID, 20, ' : ' + ISNULL( EMail, '')
           FROM [User] WHERE ([User].ID = @US)
  IF NOT EXISTS ( SELECT ID FROM UserInstall WHERE([User] = @US) AND (Line = 21))
    INSERT INTO UserInstall ([User], Line, Name)
         SELECT ID, 21, '  : ' + ISNULL( MailPass, '')
           FROM [User] WHERE ([User].ID = @US)
  INSERT INTO UserInstall ([User], Line, Title, Name)
         SELECT  @US, Line, Title, Name 
            FROM UserInstallDefault 
            WHERE(Line NOT IN (SELECT Line FROM UserInstall WHERE ([User] = @US)))
--
GO
--=====================================================================================================================
CREATE PROCEDURE GridUserInstall @US INT
AS
  SELECT ID, [User], Line, Title, Name, Done
    FROM UserInstall
    WHERE ([User] = @US)
    ORDER BY Line
--
GO
--=====================================================================================================================
-- 
-- 41	- tsk
--
--DELETE UserInstall WHERE [USER] = 41
--EXECUTE UserInstallInsert 41
--SELECT * FROM UserInstall WHERE [USER] = 41 ORDER BY Line
EXECUTE GridUserInstall 41
