{=======================================================================================================================

   " ".

       .

========================================================================================================================

  :

  15.03.2012 [+]    .
             [+]  .
  09.10.1997 [!]  .

========================================================================================================================
  Copyright 19972012 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: dgUserDCScan.pas,v 1.2 2015/03/08 05:02:40 tsk Exp $
=======================================================================================================================}
unit dgUserDCScan;

interface

uses  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics, Vcl.Controls,
      Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, DBGridEh, Vcl.Mask, DBCtrlsEh, DBLookupEh, Vcl.Buttons, Data.DB,
      Data.Win.ADODB,
      // Comming:
      CommingADO, CommingNet;

type
  TUserDCScanDG = class(TForm)
    Label1: TLabel;
    cbDomain: TDBLookupComboboxEh;
    mmLog: TMemo;
    btRun: TBitBtn;
    btExit: TBitBtn;
    spCheck: TADOStoredProc;
    procedure btRunClick(Sender: TObject);
  private   { Private declarations }
  public    { Public declarations }
    procedure Run;
  end;

var UserDCScanDG: TUserDCScanDG;

implementation

{$R *.dfm}

uses dmLookUpData, dmCommingData;

const resStart = '    %s,  %s (%s).';
      resCount = ' %d  (%s).';

//======================================================================================================================
{ TUserDCScanDG }
//======================================================================================================================
procedure TUserDCScanDG.Run;
begin
  if UserDCScanDG = nil then Application.CreateForm( TUserDCScanDG, UserDCScanDG );
  with UserDCScanDG do begin
    RequeryParameters( dmLookUp.taDomain, []);
    cbDomain.KeyValue := 1;
    ShowModal;
  end;
end;
//======================================================================================================================
procedure TUserDCScanDG.btRunClick(Sender: TObject);
  var USL: TStringList;
      Dm, Us, Nm: String;
      i, p: Integer;
begin
  USL := TStringList.Create;
  Screen.Cursor := crHourGlass;
  btRun.Enabled := False;
  btExit.Enabled := False;
  mmLog.Clear;
  mmLog.Lines.Add( Format( resStart, [ dmLookUp.taDomainDomain.AsString, dmLookUp.taDomainController.AsString,
                                                                                                TimeToStr( GetTime )]));
  GetDomainUsers( USL, dmLookUp.taDomainController.AsString );
  mmLog.Lines.Add( Format( resCount, [ USL.Count, TimeToStr( GetTime )]));
  Dm := UpperCase( dmLookUp.taDomainDomain.AsString );
  for i := 0 to USL.Count - 1 do begin
    if Pos( '$', USL[i] ) = 0 then begin
      p := Pos( '|', USL[i] );
      Us := LowerCase( Copy( USL[i], 1, p - 1 ));
      Nm := Copy( USL[i], p + 1, Length( USL[i] ));
      spCheck.Parameters[1].Value := Dm;
      spCheck.Parameters[2].Value := Us;
      spCheck.Parameters[3].Value := Nm;
      spCheck.ExecProc;
      mmLog.Lines.Add( spCheck.Parameters[4].Value );
    end;
  end;
  Screen.Cursor := crDefault;
  btRun.Enabled := True;
  btExit.Enabled := True;
  USL.Free;
end;
//======================================================================================================================
end.
